ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/deliantra/server/utils/cfutil.in
(Generate patch)

Comparing deliantra/server/utils/cfutil.in (file contents):
Revision 1.6 by root, Sun Mar 11 02:12:45 2007 UTC vs.
Revision 1.63 by root, Mon Dec 17 08:03:22 2007 UTC

6my $exec_prefix = "@exec_prefix@"; 6my $exec_prefix = "@exec_prefix@";
7my $datarootdir = "@datarootdir@"; 7my $datarootdir = "@datarootdir@";
8my $DATADIR = "@datadir@/@PACKAGE@"; 8my $DATADIR = "@datadir@/@PACKAGE@";
9 9
10my $CONVERT = "@CONVERT@"; 10my $CONVERT = "@CONVERT@";
11my $IDENTIFY = "@IDENTIFY@"; 11#my $IDENTIFY = "@IDENTIFY@";
12my $OPTIPNG = "@OPTIPNG@"; 12my $OPTIPNG = "@OPTIPNG@";
13my $RSYNC = "@RSYNC@"; 13my $RSYNC = "@RSYNC@";
14my $PNGNQ = "@PNGNQ@";
14 15
15use Getopt::Long; 16use Getopt::Long;
16use Coro::Event; 17use Coro::Event;
17use AnyEvent; 18use AnyEvent;
19use YAML::Syck ();
20use JSON::XS ();
18use IO::AIO (); 21use IO::AIO ();
19use File::Temp; 22use File::Temp;
20use Crossfire; 23use Crossfire;
21use Coro; 24use Coro;
22use Coro::AIO; 25use Coro::AIO;
26use Coro::Util;
23use POSIX (); 27use POSIX ();
24use Digest::MD5; 28use Carp;
29use Coro::Channel;
30use Coro::Storable; $Storable::canonical = 1;
31
32$SIG{QUIT} = sub { Carp::cluck "QUIT" };
25 33
26sub usage { 34sub usage {
27 warn <<EOF; 35 warn <<EOF;
28Usage: cfutil [-v] [-q] [--force] [--cache] 36Usage: cfutil [-v] [-q] [--force] [--cache]
29 [--install-arch path] 37 [--install-arch path]
41my $CACHE = 0; 49my $CACHE = 0;
42my $FORCE; 50my $FORCE;
43my $TMPDIR = "/tmp/cfutil$$~"; 51my $TMPDIR = "/tmp/cfutil$$~";
44my $TMPFILE = "aaaa0"; 52my $TMPFILE = "aaaa0";
45 53
54our %COLOR = (
55 black => 0,
56 white => 1,
57 navy => 2,
58 red => 3,
59 orange => 4,
60 blue => 5,
61 darkorange => 6,
62 green => 7,
63 lightgreen => 8,
64 grey => 9,
65 brown => 10,
66 gold => 11,
67 tan => 12,
68);
69
46END { system "rm", "-rf", $TMPDIR } 70END { system "rm", "-rf", $TMPDIR }
47 71
48Event->signal (signal => "INT", cb => sub { exit 1 }); 72Event->signal (signal => "INT", cb => sub { exit 1 });
49Event->signal (signal => "TERM", cb => sub { exit 1 }); 73Event->signal (signal => "TERM", cb => sub { exit 1 });
50 74
67} 91}
68 92
69sub inst_maps($) { 93sub inst_maps($) {
70 my (undef, $path) = @_; 94 my (undef, $path) = @_;
71 95
72 print "installing '$path' to '$DATADIR/maps'\n\n"; 96 print "\nInstalling '$path' to '$DATADIR/maps'\n\n";
73 97
74 if (!-f "$path/regions") { 98 if (!-f "$path/regions") {
75 warn "'$path' does not look like a maps directory ('regions' file is missing).\n"; 99 warn "'$path' does not look like a maps directory ('regions' file is missing).\n";
76 exit 1 unless $FORCE; 100 exit 1 unless $FORCE;
77 } 101 }
78 102
79 system $RSYNC, "-av", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded"; 103 system $RSYNC, "-av", "--chmod=u=rwX,go=rX",
104 "$path/.", "$DATADIR/maps/.",
105 "--exclude", "CVS", "--exclude", "/world-precomposed",
106 "--delete", "--delete-excluded"
107 and die "map installation failed.\n";
108
109 print "maps installed successfully.\n";
80} 110}
81 111
82{ 112{
83 our %PNG32; 113 our %ANIMINFO;
84 our %FACEINFO; 114 our %FACEINFO;
115 our %RESOURCE;
85 our @ARC; 116 our @ARC;
117 our %ARC;
118 our $TRS;
86 our $NFILE; 119 our $NFILE;
87 our %ANIM; 120 our $PATH;
88 121
89 our (@png, @trs, @arc); # files we are interested in 122 our $QUANTIZE = "+dither -colorspace RGB -colors 256";
90 123
124 our $c_arc = new Coro::Channel;
125 our $c_trs = new Coro::Channel;
126 our $c_res = new Coro::Channel;
127
128 our @c_png;
129
91 sub commit_png { 130 sub commit_png($$$) {
92 my ($name, $data) = @_; 131 my ($name, $data, $T) = @_;
93 132
94 $PNG32{$name} = $data; 133 $FACEINFO{$name}{"data$T"} = $data;
95 $FACEINFO{$name} ||= {};
96 } 134 }
97 135
98 sub process_png { 136 sub process_png {
99 while (@png) { 137 while (@c_png) {
100 my $path = pop @png; 138 my ($path, $delete) = @{pop @c_png};
101 139
102 my $png; 140 my $png;
103 aio_lstat $path; 141 aio_lstat $path;
104 my ($size, $mtime) = (stat _)[7,9]; 142 my ($size, $mtime) = (stat _)[7,9];
105 143
106 if (0 > aio_load $path, $png) { 144 if (0 > aio_load $path, $png) {
107 warn "$path: $!, skipping.\n"; 145 warn "$path: $!, skipping.\n";
108 next; 146 next;
109 } 147 }
110 148
149 my $stem = $path;
150 my $T;
151
152 if ($stem =~ s/\.32x32\.png~?$//) {
153 $T = 32;
154 } elsif ($stem =~ s/\.64x64\.png~?$//) {
155 $T = 64;
156 } else {
157 warn "$path: weird filename, skipping.\n";
158 next;
159 }
160
111 # quickly extract width and height of the (necessarily PNG) image 161 # quickly extract width and height of the (necessarily PNG) image
112 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) { 162 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) {
113 warn "$path: not a recongized png file, skipping.\n"; 163 warn "$path: not a recognized png file, skipping.\n";
114 next; 164 next;
115 } 165 }
116 166
117 my ($w, $h) = unpack "NN", $1; 167 my ($w, $h) = unpack "NN", $1;
118
119 (my $face = $path) =~ s/^.*\///;
120 my $T = 32;
121
122 unless ($face =~ s/\.base\.(...)\.png$/.$1/) {
123 warn "$path: weird filename, skipping.\n";
124 next;
125 }
126 168
127 if ($w < $T || $h < $T) { 169 if ($w < $T || $h < $T) {
128 warn "$path: too small ($w $h), skipping.\n"; 170 warn "$path: too small ($w $h), skipping.\n";
129 next; 171 next;
130 } 172 }
132 if ($w % $T || $h % $T) { 174 if ($w % $T || $h % $T) {
133 warn "$path: weird png size ($w $h), skipping.\n"; 175 warn "$path: weird png size ($w $h), skipping.\n";
134 next; 176 next;
135 } 177 }
136 178
179 (my $base = $stem) =~ s/^.*\///;
180
181 my $fi = $FACEINFO{$base};
182 unless ($fi) {
183 #warn "$path: <$base> not referenced by any archetype, skipping.\n";
184 #next;
185 }
186
187 my $arc = $fi->{arc} || { };
188
189 unless ($path =~ /~$/) {
190 # possibly enlarge
191 if (0 > aio_stat "$stem.64x64.png") {
192 my $other = "$stem.64x64.png~";
193
194 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
195 fork_sub {
196 my $CROP;
197 my $SRC = "png:\Q$path\E";
198
199 my $is_floor = $arc->{is_floor};
200 my $is_wall = 0;
201
202 my ($wall_pfx, $wall_dir, $wall_sfx);
203
204 if (
205 !$is_floor
206 && !$arc->{alive}
207 && $arc->{move_block} eq "all"
208 && $path =~ /^(.*_)([0-9A-F])(\.x11.*\.png)$/
209 ) {
210 ($wall_pfx, $wall_dir, $wall_sfx) = ($1, hex $2, $3);
211
212 unless (grep { !-e sprintf "%s%X%s", $wall_pfx, $_, $wall_sfx } 0..15) {
213 $is_wall = 1;
214 }
215 }
216
217 if ($is_wall || $is_floor) {
218 # add a 4px border and add other images around it
219 $CROP = "-shave 8x8 +repage";
220
221 $w += 8;
222 $h += 8;
223
224 $SRC = "-size ${w}x${h} xc:transparent";
225 $SRC .= " png:\Q$path\E -geometry +4+4 -composite";
226
227 # 8 surrounding images
228 for (
229 # x y b r0 r1
230 [-1, -1, 0, 6],
231 [ 0, -1, 1, 10, 14],
232 [+1, -1, 0, 12],
233
234 [-1, 0, 8, 5, 7],
235 #
236 [+1, 0, 2, 5, 13],
237
238 [-1, +1, 0, 3],
239 [ 0, +1, 4, 10, 11],
240 [+1, +1, 0, 9],
241 ) {
242 my ($x, $y, $d, $r0, $r1) = @$_;
243
244 my $tile = $is_floor ? $path
245 : $is_wall ? sprintf "%s%X%s", $wall_pfx, ($wall_dir & $d) ? $r1 : $r0, $wall_sfx
246 : die;
247
248 $SRC .= sprintf " png:%s -geometry %+d%+d -composite",
249 "\Q$tile",
250 $x * ($w - 8) + 4,
251 $y * ($h - 8) + 4;
252 }
253 }
254
255 system "convert -depth 8 $SRC rgba:-"
256 . "| $exec_prefix/bin/cfhq2xa $w $h 0"
257 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $CROP $QUANTIZE -quality 00 png32:\Q$other\E~"
258 and die "convert/cfhq2xa pipeline error: status $? ($!)";
259 system $OPTIPNG, "-i0", "-q", "$other~";
260 die "$other~ has zero size, aborting." unless -s "$other~";
261 rename "$other~", $other;
262 };
263 }
264
265 push @c_png, [$other, !$CACHE];
266 }
267
268 # possibly scale down
269 if (0 > aio_stat "$stem.32x32.png") {
270 my $other = "$stem.32x32.png~";
271
272 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
273 fork_sub {
274 system "convert png:\Q$path\E -geometry 50% -filter lanczos $QUANTIZE -quality 00 png32:\Q$other\E~";
275 system $OPTIPNG, "-i0", "-q", "$other~";
276
277 # reduce smoothfaces >10000 bytes
278 if ($stem =~ /_S\./ && (-s "$other~") > 10000) {
279 my $ncolor = 256;
280 while () {
281 system "<\Q$other~\E $PNGNQ -s1 -n$ncolor >\Q$other~~\E";
282 system $OPTIPNG, "-i0", "-q", "$other~~";
283 last if 10000 > -s "$other~~";
284 $ncolor = int $ncolor * 0.9;
285 $ncolor > 8 or die "cannot reduce filesize to < 10000 bytes";
286 }
287
288 printf "reduced %s from %d to %d bytes using %d colours.\n",
289 $other, -s "$other~", -s "$other~~", $ncolor
290 if $VERBOSE >= 2;
291 rename "$other~~", "$other~";
292 }
293
294 die "$other~ has zero size, aborting." unless -s "$other~";
295 rename "$other~", $other;
296 };
297 }
298
299 #warn "scaled down $path to $other\n";#d#
300 push @c_png, [$other, !$CACHE];
301 }
302 }
303
304 (my $face = $stem) =~ s/^.*\///;
305
306 # split all bigfaces, but avoid smoothfaces (*_S)
137 if (($w > $T || $h > $T) && $face !~ /_S\./) { 307 if (($w > $T || $h > $T) && $face !~ /_S\./) {
138 # split 308 # split
139 my @tile; 309 my @tile;
140 for my $x (0 .. (int $w / $T) - 1) { 310 for my $x (0 .. (int $w / $T) - 1) {
141 for my $y (0 .. (int $h / $T) - 1) { 311 for my $y (0 .. (int $h / $T) - 1) {
154 (map { 324 (map {
155 ( 325 (
156 "(", 326 "(",
157 "+clone", 327 "+clone",
158 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T), 328 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T),
329 "+repage",
330 -quality => "00",
159 -write => "png:$_->[2]~", 331 -write => "png32:$_->[2]~",
160 "+delete", 332 "+delete",
161 ")", 333 ")",
162 ) 334 )
163 } @todo), 335 } @todo),
164 "null:"; 336 "null:";
168 close $convert; 340 close $convert;
169 341
170 # pass 2, optimise, and rename 342 # pass 2, optimise, and rename
171 for (@todo) { 343 for (@todo) {
172 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~"; 344 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~";
345 die "$_->[2]~ has zero size, aborting." unless -s "$_->[2]~";
173 rename "$_->[2]~", $_->[2]; 346 rename "$_->[2]~", $_->[2];
174 } 347 }
175 }; 348 };
176 } 349 }
177 350
181 354
182 if (0 > aio_load $file, $tile) { 355 if (0 > aio_load $file, $tile) {
183 die "$path: unable to read tile +$x+$y, aborting.\n"; 356 die "$path: unable to read tile +$x+$y, aborting.\n";
184 } 357 }
185 IO::AIO::aio_unlink $file unless $CACHE; 358 IO::AIO::aio_unlink $file unless $CACHE;
186 commit_png $x|$y ? "$face+$x+$y" : $face, $tile; 359 commit_png $x|$y ? "$face+$x+$y" : $face, $tile, $T;
187 } 360 }
188 } else { 361 } else {
189 # use as-is (either small, use smooth) 362 # use as-is (either small, use smooth)
190 commit_png $face, $png; 363 commit_png $face, $png, $T;
191 } 364 }
365
366 aio_unlink $path if $delete;
192 } 367 }
193 } 368 }
194 369
195 sub process_arc { 370 sub process_arc {
196 while (@arc) { 371 while (my $job = $c_arc->get) {
197 my ($dir, $file) = @{pop @arc}; 372 my ($dir, $file) = @$job;
198 373
199 my $arc; 374 my $arc;
200 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/ 375 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/
201 376
202 my $arc = read_arch "$dir/$file"; 377 my $arc = read_arch "$dir/$file";
203 for my $o (values %$arc) { 378 for my $o (values %$arc) {
204 push @ARC, $o; 379 push @ARC, $o;
380 for (my $m = $o; $m; $m = $m->{more}) {
381 $ARC{$m->{_name}} = $m;
382 }
383
384 $o->{editor_folder} = $dir;
205 385
206 my $visibility = delete $o->{visibility}; 386 my $visibility = delete $o->{visibility};
207 my $magicmap = delete $o->{magicmap}; 387 my $magicmap = delete $o->{magicmap};
208 388
209 # find upper left corner :/ 389 # find upper left corner :/
218 my $x = $o->{x} - $dx; 398 my $x = $o->{x} - $dx;
219 my $y = $o->{y} - $dy; 399 my $y = $o->{y} - $dy;
220 400
221 my $ext = $x|$y ? "+$x+$y" : ""; 401 my $ext = $x|$y ? "+$x+$y" : "";
222 402
223 $o->{face} .= $ext; 403 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/ || !$o->{face};
224 404
225 my $visibility = delete $o->{visibility} if exists $o->{visibility}; 405 $visibility = delete $o->{visibility} if exists $o->{visibility};
226 my $magicmap = delete $o->{magicmap} if exists $o->{magicmap}; 406 $magicmap = delete $o->{magicmap} if exists $o->{magicmap};
227 407
228 my $anim = delete $o->{anim}; 408 my $anim = delete $o->{anim};
229 409
230 if ($anim) { 410 if ($anim) {
411 # possibly add $ext to the animation name to avoid
412 # the need to specify archnames for all parts
413 # of a multipart archetype.
231 $o->{animation} = "$o->{_name}$ext"; 414 $o->{animation} = "$o->{_name}";
415 my $facings = 1;
416 my @frames;
232 417
233 for (@$anim) { 418 for (@$anim) {
234 $_ .= $ext unless /^facings\s/; 419 if (/^facings\s+(\d+)/) {
420 $facings = $1*1;
421 } elsif (/^blank.x11$|^empty.x11$/) {
422 push @frames, $_;
423 } else {
424 push @frames, "$_$ext";
425 }
235 } 426 }
236 427
237 $ANIM{"$o->{_name}$ext"} = 428 $ANIMINFO{$o->{animation}} = {
238 join "", map "$_\n", 429 facings => $facings,
239 "anim $o->{_name}$ext", 430 frames => \@frames,
240 @$anim,
241 "mina";
242 } 431 };
432 }
243 433
244 for my $face ($o->{face} || (), @{$anim || []}) { 434 for ($o->{face} || (), @{$anim || []}) {
245 next if /^facings\s/; 435 next if /^facings\s/;
246 436
437 my $face = $_;
438 $face =~ s/\+\d+\+\d+$//; # remove tile offset coordinates
439
247 my $info = $FACEINFO{$face} ||= {}; 440 my $info = $FACEINFO{$face} ||= { };
441 $info->{arc} = $o;
442
443 next if $face =~ /^blank.x11$|^empty.x11$/;
248 444
249 $info->{visibility} = $visibility if defined $visibility; 445 $info->{visibility} = $visibility if defined $visibility;
250 $info->{magicmap} = $magicmap if defined $magicmap; 446 $info->{magicmap} = $magicmap if defined $magicmap;
251 } 447 }
448
449 if (my $smooth = delete $o->{smoothface}) {
450 my %kv = split /\s+/, $smooth;
451 my $level = $o->{smoothlevel}; #TODO: delete from $o if !gcfclient-support
452 while (my ($face, $smooth) = each %kv) {
453 $FACEINFO{$smooth}{arc} = $o;
454
455 $FACEINFO{$face}{smooth} = $smooth;
456 $FACEINFO{$face}{smoothlevel} = $level;
457 }
458 }
252 } 459 }
253 } 460 }
254 } 461 }
255 } 462 }
256 463
257 sub process_trs { 464 sub process_trs {
258 while (@trs) { 465 while (my $job = $c_trs->get) {
259 my ($dir, $file) = @{pop @trs}; 466 my ($dir, $file) = @$job;
467 my $path = "$dir/$file";
468
469 my $trs;
470 if (0 > aio_load $path, $trs) {
471 warn "$path: $!, skipping.\n";
472 next;
473 }
474
475 $TRS .= $trs;
476 }
477 }
478
479 my %FILECACHE;
480
481 sub load_cached($;$) {
482 unless (exists $FILECACHE{$_[0]}) {
483 my $data;
484 if (0 < aio_load $_[0], $data) {
485 if ($_[1]) {
486 $data = eval { $_[1]->($data) };
487 warn "$_[0]: $@" if $@;
488 }
489 }
490
491 $FILECACHE{$_[0]} = $data;
492 }
493
494 $FILECACHE{$_[0]}
495 }
496
497 sub process_res {
498 while (my $job = $c_res->get) {
499 my ($dir, $file, $type) = @$job;
500
501 my $data;
502 aio_load "$dir/$file", $data;
503
504 my $meta = load_cached "$dir/meta", sub { JSON::XS->new->utf8->relaxed->decode (shift) };
505
506 utf8::decode $dir;
507 utf8::decode $file;
508
509 # a meta file for resources is now mandatory
510 unless (exists $meta->{$file}) {
511 warn "skipping $dir/$file\n" if $VERBOSE >= 3;
512 }
513
514 $meta = {
515 %{ $meta->{"" } || {} },
516 %{ $meta->{$file} || {} },
517 };
518
519 if ($meta->{license} =~ s/^#//) {
520 $meta->{license} = ({
521 "pd" => "Public Domain",
522 "gpl" => "GNU General Public License, version 3.0 or any later",
523 "cc/by/2.0" => "Licensed under Creative Commons Attribution 2.0 http://creativecommons.org/licenses/by/2.0/",
524 "cc/by/2.5" => "Licensed under Creative Commons Attribution 2.5 http://creativecommons.org/licenses/by/2.5/",
525 "cc/by/3.0" => "Licensed under Creative Commons Attribution 3.0 http://creativecommons.org/licenses/by/3.0/",
526 })->{$meta->{license}}
527 || warn "$dir/$file: license tag '$meta->{license}' not found.";
528 }
529
530 $file =~ s/\.res$//;
531 $file =~ s/\.(ogg|wav|jpg|png)$//;
532
533 substr $dir, 0, 1 + length $PATH, "";
534
535 if (my $filter = $meta->{cfutil_filter}) {
536 if ($filter eq "yaml2json") {
537 $data = JSON::XS::encode_json YAML::Syck::Load $data;
538 } else {
539 warn "$dir/$file: unknown filter $filter, skipping\n";
540 }
541 }
542
543 $RESOURCE{"$dir/$file"} = {
544 type => (exists $meta->{type} ? delete $meta->{type} : $type),
545 data => $data,
546 %$meta ? (meta => $meta) : (),
547 };
260 } 548 }
261 } 549 }
262 550
263 sub find_files; 551 sub find_files;
264 sub find_files { 552 sub find_files {
269 my ($dirs, $nondirs) = @_; 557 my ($dirs, $nondirs) = @_;
270 558
271 find_files "$path/$_" 559 find_files "$path/$_"
272 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs; 560 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs;
273 561
562 my $dir = $path;
563 substr $dir, 0, 1 + length $PATH, "";
564
274 for my $file (@$nondirs) { 565 for my $file (@$nondirs) {
566 if ($dir =~ /^music(?:\/|$)/) {
567 $c_res->put ([$path, $file, 3]) # FT_MUSIC
568 if $file =~ /\.(ogg)$/;
569
570 } elsif ($dir =~ /^sound(?:\/|$)/) {
571 $c_res->put ([$path, $file, 5]) # FT_SOUND
572 if $file =~ /\.(wav|ogg)$/;
573
574 } elsif ($dir =~ /^res(?:\/|$)/) {
575 if ($file =~ /\.(jpg|png)$/) {
576 $c_res->put ([$path, $file, 0]) # FT_FACE
577 } elsif ($file =~ /\.(res)$/) {
578 $c_res->put ([$path, $file, 7]) # FT_RSRC
579 } else {
580 $c_res->put ([$path, $file, undef]);
581 }
582
275 if ($file =~ /\.png$/) { 583 } elsif ($file =~ /\.png$/) {
276 push @png, "$path/$file"; 584 push @c_png, ["$path/$file", 0];
585
277 } elsif ($file =~ /\.trs$/) { 586 } elsif ($file =~ /\.trs$/) {
278 push @trs, [$path, $file]; 587 $c_trs->put ([$path, $file]);
588
279 } elsif ($file =~ /\.arc$/) { 589 } elsif ($file =~ /\.arc$/) {
280 push @arc, [$path, $file]; 590 $c_arc->put ([$path, $file]);
591
281 } else { 592 } else {
282 warn "ignoring $path/$file\n" if $VERBOSE >= 2; 593 warn "ignoring $path/$file\n" if $VERBOSE >= 3;
283 } 594 }
284 } 595 }
285 }; 596 };
286 } 597 }
287 598
288 sub inst_arch($) { 599 sub inst_arch($) {
289 my (undef, $path) = @_; 600 my (undef, $path) = @_;
290 601
602 $PATH = $path;
603
604 print "\n",
291 print "installing '$path' to '$DATADIR'\n\n"; 605 "Installing '$path' to '$DATADIR'\n",
606 "\n",
607 "This can take a long time if you run this\n",
608 "for the first time or do not use --cache.\n",
609 "\n",
610 "Unless you run verbosely, all following warning\n",
611 "or error messages indicate serious problems.\n",
612 "\n";
292 613
293 if (!-d "$path/treasures") { 614 if (!-d "$path/treasures") {
294 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n"; 615 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n";
295 exit 1 unless $FORCE; 616 exit 1 unless $FORCE;
296 } 617 }
297 618
619 print "scanning files...\n" if $VERBOSE;
620
298 find_files $path; 621 find_files $path;
622
623 my @a_arc = map +(async \&process_arc), 1..2;
624 my @a_res = map +(async \&process_res), 1..2;
625 my @a_trs = map +(async \&process_trs), 1..2;
626
299 IO::AIO::flush; 627 IO::AIO::flush;
300 628
301 $_->join for ( 629 $c_res->put (undef) for @a_res;
302 (async \&process_png), (async \&process_png), 630 $c_arc->put (undef) for @a_arc;
303 (async \&process_trs), (async \&process_trs), 631 $c_trs->put (undef) for @a_trs;
304 (async \&process_arc), (async \&process_arc),
305 );
306 632
633 print "start file scan, arc, res processing...\n" if $VERBOSE;
634
635 $_->join for @a_arc; # need to parse all archetypes before png processing
636
637 print "end arc, start png processing...\n" if $VERBOSE;
638
639 # four png crunchers work fine for my 2x smp machine
640 my @a_png = map +(async \&process_png), 1..4;
641
642 $_->join for (@a_trs, @a_res, @a_png);
643
644 print "scanning done, processing results...\n" if $VERBOSE;
307 { 645 {
308 open my $fh, ">:utf8", "$DATADIR/animations~" 646 # remove path prefix from editor_folder
309 or die "$DATADIR/animations~: $!"; 647 substr $_->{editor_folder}, 0, 1 + length $path, ""
310 print $fh join "", map $ANIM{$_}, sort keys %ANIM 648 for values %ARC;
649
650 print "resolving inheritance tree...\n" if $VERBOSE;
651 # resolve inherit
652 while () {
653 my $progress;
654 my $loop;
655
656 for my $o (values %ARC) {
657 if (my $other = $o->{inherit}) {
658 if (my $s = $ARC{$other}) {
659 if ($s->{inherit}) {
660 $loop = $s;
661 } else {
662 delete $o->{inherit};
663 my %s = %$s;
664 delete @s{qw(_name more name name_pl)};
665 %$o = ( %s, %$o );
666 ++$progress;
667 }
668 } else {
669 warn "'$o->{_name}' tries to inherit from undefined archetype '$other', skipping.\n";
670 delete $ARC{$o->{_name}};
671 }
672 }
673 }
674
675 unless ($progress) {
676 die "inheritance loop detected starting at archetype '$loop->{_name}', aborting.\n"
677 if $loop;
678
679 last;
680 }
311 } 681 }
312 682
313 { 683 # remove base classes (by naming scheme, should use something like "baseclass xxx" to inherit
684 @ARC = grep $_->{_name} !~ /^(?:type|class)_/, @ARC;
685
686 print "writing archetypes...\n" if $VERBOSE;
314 open my $fh, ">:utf8", "$DATADIR/archetypes~" 687 open my $fh, ">:utf8", "$DATADIR/archetypes~"
315 or die "$DATADIR/archetypes~: $!"; 688 or die "$DATADIR/archetypes~: $!";
316 print $fh Crossfire::archlist_to_string \@ARC; 689 print $fh Crossfire::archlist_to_string [sort { $a->{_name} cmp $b->{_name} } @ARC];
317 } 690 }
318 691
319 { 692 {
693 print "writing treasures...\n" if $VERBOSE;
694 open my $fh, ">:utf8", "$DATADIR/treasures~"
695 or die "$DATADIR/treasures~: $!";
696 print $fh $TRS;
697 }
698
699 {
700 print "processing facedata...\n" if $VERBOSE;
320 while (my ($k, $v) = each %FACEINFO) { 701 while (my ($k, $v) = each %FACEINFO) {
321 $v->{data32} ||= delete $PNG32{$k}; 702 length $v->{data32} or warn "$k: face has no png32. this will not work (shoddy gcfclient will crash of course).\n";
703 length $v->{data64} or warn "$k: face has no png64. this will not work very well.\n";
704
705 length $v->{data32} <= 10000 or warn "$k: face32 larger than 10000 bytes, will not work with crossfire client.\n";
706 #length $v->{data64} <= 10000 or warn "$k: face64 larger than 10000 bytes.\n";
707
708 if (my $magicmap = $v->{magicmap}) {
709 $magicmap =~ y/A-Z_\-/a-z/d;
710 $v->{magicmap} = $COLOR{$magicmap};
322 } 711 }
323 712
324 while (my ($k, $v) = each %FACEINFO) { 713 delete $v->{arc};
325 exists $v->{data32} or warn "$k: face has no png32. this will crash the server.\n";
326
327 $v->{chksum32} = Digest::MD5::md5 $v->{data32};
328 } 714 }
329 715
716 print "writing facedata...\n" if $VERBOSE;
330 open my $fh, ">:perlio", "$DATADIR/faces~" 717 open my $fh, ">:perlio", "$DATADIR/facedata~"
331 or die "$DATADIR/faces~: $!"; 718 or die "$DATADIR/facedata~: $!";
332 719
333 print $fh Storable::nfreeze \%FACEINFO; 720 print $fh freeze {
334 721 version => 2,
335 #use PApp::Util; warn PApp::Util::dumpval \%FACEINFO; 722 faceinfo => \%FACEINFO,
723 animinfo => \%ANIMINFO,
724 resource => \%RESOURCE,
336 } 725 };
726 }
337 727
728 print "committing files...\n" if $VERBOSE;
729
338 for (qw(archetypes faces animations)) { 730 for (qw(archetypes facedata treasures)) {
339 chmod 0644, "$DATADIR/$_~"; 731 chmod 0644, "$DATADIR/$_~";
340 rename "$DATADIR/$_~", "$DATADIR/$_"; 732 rename "$DATADIR/$_~", "$DATADIR/$_"
733 or die "$DATADIR/$_: $!";
341 } 734 }
342 735
343 die "--install-arch not fully implemented\n"; 736 print "archetype data installed successfully.\n";
344 } 737 }
345} 738}
346 739
347Getopt::Long::Configure ("bundling", "no_ignore_case"); 740Getopt::Long::Configure ("bundling", "no_ignore_case");
348GetOptions ( 741GetOptions (

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines